<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>The m17n Library: Input Method (GUI)</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Input Method (GUI)<br/>
<small>
[<a class="el" href="group__m17nGUI.html">GUI API</a>]</small>
</h1>
<p>Input method support on window systems.  
<a href="#_details">More...</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Data Structures</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputGUIArgIC.html">MInputGUIArgIC</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Type of the argument to the function <a class="el" href="group__m17nInputMethod.html#ga8b32df84c645f73ed65e20a1d51c1859" title="Create an input context.">minput_create_ic()</a>.  <a href="structMInputGUIArgIC.html#_details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputXIMArgIM.html">MInputXIMArgIM</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Structure pointed to by the argument <b>arg</b> of the function <a class="el" href="group__m17nInputMethod.html#ga34d3e527bfd705d2b7f2b749199c1e11" title="Open an input method.">minput_open_im()</a>.  <a href="structMInputXIMArgIM.html#_details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputXIMArgIC.html">MInputXIMArgIC</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Structure pointed to by the argument <b>arg</b> of the function <a class="el" href="group__m17nInputMethod.html#ga8b32df84c645f73ed65e20a1d51c1859" title="Create an input context.">minput_create_ic()</a>.  <a href="structMInputXIMArgIC.html#_details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethodWin.html#ga58715c630a04fd33f12394e9c93f1bad">minput_event_to_key</a> (<a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *frame, void *event)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Convert an event to an input key.  <a href="#ga58715c630a04fd33f12394e9c93f1bad"></a><br/></td></tr>
<tr><td colspan="2"><h2>Variables</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structMInputDriver.html">MInputDriver</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethodWin.html#ga382ffd93fbaaa7226dd36af4a3fd7100">minput_gui_driver</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Input driver for internal input methods on window systems.  <a href="#ga382ffd93fbaaa7226dd36af4a3fd7100"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethodWin.html#ga4e8d34da33638639ecc7386914def510">Mxim</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol of the name "xim".  <a href="#ga4e8d34da33638639ecc7386914def510"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>Input method support on window systems. </p>
<p>The input driver <code>minput_gui_driver</code> is provided for internal input methods that is useful on window systems. It displays preedit text and status text at the inputting spot. See the documentation of <code>minput_gui_driver</code> for more details.</p>
<p>In the m17n-X library, the foreign input method of name <code>Mxim</code> is provided. It uses XIM (X Input Method) as a background input engine. The symbol <code>Mxim</code> has a property <code>Minput_driver</code> whose value is a pointer to the input driver <code>minput_xim_driver</code>. See the documentation of <code>minput_xim_driver</code> for more details. </p>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="ga58715c630a04fd33f12394e9c93f1bad"></a><!-- doxytag: member="input&#45;gui.c::minput_event_to_key" ref="ga58715c630a04fd33f12394e9c93f1bad" args="(MFrame *frame, void *event)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> minput_event_to_key </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nFrame.html#gabb36d3a69526a891ce7534bda63a2687">MFrame</a> *&nbsp;</td>
          <td class="paramname"> <em>frame</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>event</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Convert an event to an input key. </p>
<p>The <a class="el" href="group__m17nInputMethodWin.html#ga58715c630a04fd33f12394e9c93f1bad" title="Convert an event to an input key.">minput_event_to_key()</a> function returns the input key corresponding to event <b>event</b> on <b>frame</b> by a window system dependent manner.</p>
<p>In the m17n-X library, <b>event</b> must be a pointer to the structure <code>XKeyEvent</code>, and it is handled as below.</p>
<p>At first, the keysym name of <b>event</b> is acquired by the function <code>XKeysymToString</code>. Then, the name is modified as below.</p>
<p>If the name is one of "a" .. "z" and <b>event</b> has a Shift modifier, the name is converted to "A" .. "Z" respectively, and the Shift modifier is cleared.</p>
<p>If the name is one byte length and <b>event</b> has a Control modifier, the byte is bitwise anded by 0x1F and the Control modifier is cleared.</p>
<p>If <b>event</b> still has modifiers, the name is preceded by "S-" (Shift), "C-" (Control), "M-" (Meta), "A-" (Alt), "G-" (AltGr), "s-" (Super), and "H-" (Hyper) in this order.</p>
<p>For instance, if the keysym name is "a" and the event has Shift, Meta, and Hyper modifiers, the resulting name is "M-H-A".</p>
<p>At last, a symbol who has the name is returned. </p>

</div>
</div>
<hr/><h2>Variable Documentation</h2>
<a class="anchor" id="ga382ffd93fbaaa7226dd36af4a3fd7100"></a><!-- doxytag: member="input&#45;gui.c::minput_gui_driver" ref="ga382ffd93fbaaa7226dd36af4a3fd7100" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structMInputDriver.html">MInputDriver</a> <a class="el" href="group__m17nInputMethodWin.html#ga382ffd93fbaaa7226dd36af4a3fd7100">minput_gui_driver</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Input driver for internal input methods on window systems. </p>
<p>The input driver <code>minput_gui_driver</code> is for internal input methods to be used on window systems.</p>
<p>It creates sub-windows for a preedit text and a status text, and displays them at the input spot set by the function <a class="el" href="group__m17nInputMethod.html#gac12030bd2d5c265a7327a9487f9c1376" title="Set the spot of the input context.">minput_set_spot()</a>.</p>
<p>The macro <a class="el" href="group__m17nIntro.html#ga66879b35a1fee08b3e5966f6650c39f9" title="Initialize the m17n library.">M17N_INIT()</a> set the variable <code>minput_driver</code> to the pointer to this driver so that all internal input methods use it.</p>
<p>Therefore, unless <code>minput_driver</code> is changed from the default, the driver dependent arguments to the functions whose name begin with minput_ must are treated as follows.</p>
<p>The argument <b>arg</b> of the function <a class="el" href="group__m17nInputMethod.html#ga34d3e527bfd705d2b7f2b749199c1e11" title="Open an input method.">minput_open_im()</a> is ignored.</p>
<p>The argument <b>arg</b> of the function <a class="el" href="group__m17nInputMethod.html#ga8b32df84c645f73ed65e20a1d51c1859" title="Create an input context.">minput_create_ic()</a> must be a pointer to the structure <code><a class="el" href="structMInputGUIArgIC.html" title="Type of the argument to the function minput_create_ic().">MInputGUIArgIC</a></code>. See the documentation of <code><a class="el" href="structMInputGUIArgIC.html" title="Type of the argument to the function minput_create_ic().">MInputGUIArgIC</a></code> for more details.</p>
<p>If the argument <b>key</b> of function <a class="el" href="group__m17nInputMethod.html#ga6d9c3c97524114496fd8b7f70af92457" title="Filter an input key.">minput_filter()</a> is <code>Mnil</code>, the argument <b>arg</b> must be a pointer to the object of type <code>XEvent</code>. In that case, <b>key</b> is generated from <b>arg</b>.</p>
<p>The argument <b>arg</b> of the function <a class="el" href="group__m17nInputMethod.html#gafe533480c705b877189938a0eecb1b57" title="Look up a text produced in the input context.">minput_lookup()</a> must be the same one as that of the function <a class="el" href="group__m17nInputMethod.html#ga6d9c3c97524114496fd8b7f70af92457" title="Filter an input key.">minput_filter()</a>. </p>

</div>
</div>
<a class="anchor" id="ga4e8d34da33638639ecc7386914def510"></a><!-- doxytag: member="input&#45;gui.c::Mxim" ref="ga4e8d34da33638639ecc7386914def510" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nInputMethodWin.html#ga4e8d34da33638639ecc7386914def510">Mxim</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol of the name "xim". </p>
<p>The variable Mxim is a symbol of name "xim". It is a name of the input method driver <a class="el" href="m17n-X_8h.html#aa416d384957c7e4f69349d62f74e1a19">minput_xim_driver</a>. </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-en/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
